<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__pra" kind="group">
    <compoundname>group_pra</compoundname>
    <title>PRA          (Protected Register Access)</title>
    <innergroup refid="group__group__pra__macros">Macros</innergroup>
    <innergroup refid="group__group__pra__functions">Functions</innergroup>
    <innergroup refid="group__group__pra__enums">Enumerated Types</innergroup>
    <innergroup refid="group__group__pra__data__structures__cfg">Data Structures</innergroup>
    <innergroup refid="group__group__pra__data__structures">Group_pra_data_structures</innergroup>
    <briefdescription>
<para>The Protected Register Access (PRA) driver used to provice access to the protected registers to a non-secure application on PSoC 64 devices. </para>    </briefdescription>
    <detaileddescription>
<para>The PRA PDL driver is only intended for the PSoC 64 devices as it provides access only to the registers that have PSoC 64 access restrictions. Refer to device technical reference manual (TRM) for the list of the protected registers.</para><para>The driver is not expected to be used directly, instead the PDL functions affected by PSoC 64 access restrictions are updated to access registers with PRA API.</para>
<para><heading level="1">More Information</heading></para>
<para>See the device technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The LVD driver has the following specific deviations: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;13.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Boolean operations whose results are invariant shall not be permitted. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;False positive. The &lt;a href="group__group__pra__functions.html#group__group__pra__functions_1ga0a1b71a4d148280527ca98aba144a6f4"&gt;Cy_PRA_SendCmd()&lt;/a&gt; compiled for Cortex-M4 has a shared variable that is modified by Cortex-M0+ application, but the analysis tool is not aware of this fact.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;14.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;There shall be no unreachable code. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;False positive. The &lt;a href="group__group__pra__functions.html#group__group__pra__functions_1ga0a1b71a4d148280527ca98aba144a6f4"&gt;Cy_PRA_SendCmd()&lt;/a&gt; compiled for Cortex-M4 has a shared variable that is modified by Cortex-M0+ application and used in a condition statement, but the analysis tool is not aware of this fact.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;14.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A function shall have a single point of exit at the end of the function. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;There are few functions with multiple points of exit implemented to simplify functions design.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;19.13 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The # and ## operators should not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The ## preprocessor operator is used in macros to form the field mask.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The validity of values passed to library functions shall be checked. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The additional check to eliminate possibility of accessing beyond array in Cy_PRA_ProcessCmd().  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>